#include "thumbnailer.h"

Thumbnailer::Thumbnailer(const QUrl &url)
{    

    //use browser plugins
    page.settings()->setAttribute(QWebSettings::PluginsEnabled, false);

    //load the url
    page.mainFrame()->load(url);
    connect(&page, SIGNAL(loadFinished(bool)),
            this, SLOT(waitForSnapShot()));
}

void Thumbnailer::waitForSnapShot(){

    //wait for 4 seconds befor rendering
    QTimer::singleShot(4000, this, SLOT(render()));

}

void Thumbnailer::render()
{
    QSize targetSize = QSize(400, 300);
    QSize size = page.mainFrame()->contentsSize();
    size.setHeight(size.width() * targetSize.height() / targetSize.width());

    page.setViewportSize(page.mainFrame()->contentsSize());

    QImage image(size, QImage::Format_ARGB32);
    QPainter painter(&image);

    page.mainFrame()->render(&painter);
    painter.end();

    QImage thumbnail = image.scaled(targetSize,Qt::KeepAspectRatioByExpanding, Qt::SmoothTransformation);
    thumbnail.save("thumbnail.png");

    emit finished();
}
